/* -*-	Mode:C++ -*- */

/*
 * change_tracking.h
 * Copyright (C) 1999 by John Heidemann
 * $Id: change_tracking.hh,v 1.4 1999/08/07 06:32:00 johnh Exp $
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License,
 * version 2, as published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
 *
 */


#ifndef lavaps_change_tracking_h
#define lavaps_change_tracking_h

template <class T>
class change_tracking {
protected:
	T last_;
	T change_;
public:
	// gcc won't accept :last_(0)
	// with error ``only constructors take base initializers''
	change_tracking() { last_ = 0; }   // xxx: should track whether we're init'ed
	change_tracking(T first) { last_ = first; }   // the last should be first
	// void init(T first) { last_ = change_ = first; }
	void tick_set(T current) { change_ = current - last_; last_ = current; }
	void tick_incr(T delta) { change_ = delta; last_ += delta; }
	T last() { return last_; }
	T change() { return change_; }
	bool changed() { return change_ != 0; }
};

#endif /* lavaps_change_tracking_h */
